#!/usr/bin/perl
use strict;
use warnings;

my $oldDB = "oldDB.fa";
my $newDB = "newDB.fa ";

my $list = "result.txt";


### Check the programs are present in the current directory.
unless(-e "./formatdb") {
  print "formatdb was not found in the current directory.\n";
  print "Program stopped.\n";
  exit;
}
unless(-e "./blastall") {
  print "blastall was not found in the current directory.\n";
  print "Program stopped.\n";
  exit;
}

### Format the databases
system("./formatdb -p T -i $newDB");

### Pick up the record from old file
my $oldName = "";
my $oldSeq = "";
my $flag = 0;
my $tempCorIDb = "";
my $hitName = "";
my $hitName1 = "";
my $hitSeq = "";
my $counter = 0;

open(OLD,"$oldDB");
open(RES,">$list");
while(my $line = <OLD>){
  chomp($line);
  if($line =~ /^>/){
    if($flag == 0){
      $oldName = $line;
      $flag = 1;
    } else {

      $counter++;
      $tempCorIDb = &blastP($counter,$oldName,$oldSeq);
      $oldName =~ s/ .*$//g;

      if($tempCorIDb =~ /^$/){
        $hitName = ">NoHit";
        $hitSeq = "NoHit";
      } else {
        ($hitName,$hitSeq) = &seqPicker($tempCorIDb,$newDB);
      }
      $hitName1 = $hitName;
      $hitName1 =~ s/ .*$//g;

      print RES "## $counter. Old: $oldName\t New: $hitName1\n";
      print RES "$oldName\n$oldSeq\n";
      print RES "$hitName\n$hitSeq\n\n";      

      $oldName = $line;
      $oldSeq = "";
#      $tempCorIDb = "";
#      $hitName = "";
#      $hitSeq = "";
      
    }
  } else {
    $oldSeq .= $line;
  }
}

### Last record.


      $counter++;
      $tempCorIDb = &blastP($counter,$oldName,$oldSeq);
      $oldName =~ s/ .*$//g;

      if($tempCorIDb =~ /^$/){
        $hitName = ">NoHit";
        $hitSeq = "NoHit";
      } else {
        ($hitName,$hitSeq) = &seqPicker($tempCorIDb,$newDB);
      }
      $hitName1 = $hitName;
      $hitName1 =~ s/ .*$//g;

      print RES "## $counter. Old: $oldName\t New: $hitName1\n";
      print RES "$oldName\n$oldSeq\n";
      print RES "$hitName\n$hitSeq\n\n";      



close RES;
close OLD;


exit;

################################################################
########
sub blastP {
  my ($counterSR, $nameSR, $oldSeqSR) = @_;
  my $tempQuery = $counterSR."_tempQuery.txt";
  my $tempOut = $counterSR."_tempOut.txt";
  
  open(TEMP,">$tempQuery");
  print TEMP "$oldName\n";
  print TEMP "$oldSeqSR\n";
  close TEMP;

  system("./blastall -p blastp -d ./$newDB -i $tempQuery -b 1 -o $tempOut");

  
  my $corIDa = &blastOutPicker($tempOut);
  unlink ($tempQuery,$tempOut);                  ##  <=  Comment out this line if you want to see the results of Blast search
  return ($corIDa);
}


sub blastOutPicker {
  my $outFile = shift@_;
  my $corrID = "";
  open(OUTBO,"$outFile");
  while(my $outLine = <OUTBO>){
    if($outLine =~ /^>/){
      chomp($outLine);
      $corrID = $outLine;
      last;
    }
  }
  $corrID =~ s/ .*$//g;
#  $corrID =~ s/^>//g;
  return($corrID);
}


### A subroutine to pick up the seqences using enstID from the database
# This subroutine uses "while", so it assumes one records for one ID in the DB.
sub seqPicker{

  my ($enst,$dbName) = @_;
#  print "$enst,$dbName\n";

  my $flag = 0;
  my $key = "";                # key of the above hash
  my $oldSeq = "";                # seq of the above hash

  open(INFILEWH,"$dbName") or die "$!";
  while (my $dbLine = <INFILEWH>) {
    chomp($dbLine);
    if($flag == 1){
      if($dbLine =~ /^>/){
        last;
      } else {
        $oldSeq .= $dbLine;
      }
    }
    if($dbLine =~ /^>/ && $dbLine =~ /$enst/ ){
      $key = $dbLine;
      $flag = 1;
    }
  }
  
  # Printout
  close INFILEWH;

  return($key,$oldSeq);

}



